(** A graph-tableau-based decision procedure framework for coalgebraic logics.
    @author Florian Widmann
 *)


type sortTable = (CoAlgMisc.functors * int list) array

type nomTable = string -> CoAlgFormula.sort option

type assumptions = CoAlgFormula.sortedFormula list

type input = sortTable * nomTable * assumptions * CoAlgFormula.sortedFormula

exception ReasonerError of string

val isSat : ?verbose:bool -> sortTable -> (string -> CoAlgFormula.sort option) ->
  CoAlgFormula.sortedFormula list -> CoAlgFormula.sortedFormula -> bool


val initReasoner : sortTable -> (string -> CoAlgFormula.sort option) ->
  CoAlgFormula.sortedFormula list -> CoAlgFormula.sortedFormula -> unit

val runReasonerStep : unit -> unit
val reasonerFinished : unit -> bool
val isRootSat : unit -> bool option
